#ifndef USER_H
#define USER_H

#include <map>
#include <vector>
#include <wx/wx.h>
#include <wx/colour.h>

#include "Category.h"
#include "Account.h"
#include "Operation.h"

class User
{
 public:
  ~User();

  wxString _id;
  wxString _name;
  wxString _password;
  std::vector<Account> _accounts;
  std::map<unsigned int, std::map<unsigned int, std::vector<Operation> >* > _operations;
  std::vector<Category> _categories;
  std::map<wxString, wxString> _preferences;

  Category GetCategory(wxString& catId);
  wxString GetCategoryName(wxString& catId);
  wxString GetCategoryId(wxString& catName);
  wxString GetAccountName(wxString& accountId);
  wxString GetAccountId(wxString& accountName);
  int GetCategoriesNumber();
  int GetAccountsNumber();
  int GetOperationsNumber(int month, int year);
  wxLanguage GetLanguage();
};

#endif
