#ifndef BUTTONPANEL_H
#define BUTTONPANEL_H

#include <wx/wx.h>
#include <wx/bmpbuttn.h>

#include <controller/KissCount.h>
#include "wxUI.h"

#define ACCOUNT_ICON "ressources/icons/administrator-icon.png"
#define STATS_ICON   "ressources/icons/chart-icon.png"
#define SEARCH_ICON  "ressources/icons/Search-icon.png"
#define PREFS_ICON   "ressources/icons/options-icon.png"
#define CHANGE_USER_ICON "ressources/icons/Clients-icon.png"
#define ABOUT_ICON  "ressources/icons/windows-users-icon.png"
#define QUIT_ICON   "ressources/icons/system-log-out.png"

class KissCount;
class wxUI;

class ButtonPanel: public wxPanel
{
 public:

  ButtonPanel(KissCount* kiss, wxUI *parent);
  ~ButtonPanel();

  void OnButtonAccount(wxCommandEvent& event);
  void OnButtonPreferences(wxCommandEvent& event);
  void OnButtonChangeUser(wxCommandEvent& event);
  void OnButtonAbout(wxCommandEvent& event);
  void OnButtonQuit(wxCommandEvent& event);

 private:
  KissCount* _kiss;
  wxUI* _wxUI;
  wxBitmapButton* _account;
  wxBitmapButton* _stats;
  wxBitmapButton* _search;
  wxBitmapButton* _prefs;
  wxBitmapButton* _changeUser;
  wxBitmapButton* _about;
  wxBitmapButton* _quit;

  DECLARE_EVENT_TABLE();
};

#endif
