#ifndef PREFERENCESPANEL_H
#define PREFERENCESPANEL_H

#include <wx/wx.h>
#include <wx/grid.h>
#include <wx/treectrl.h>
#include <wx/statbox.h>
#include <wx/gbsizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/bmpcbox.h>

#include <controller/KissCount.h>
#include "wxUI.h"
#include <model/model.h>
#include "PasswordDialog.h"
#include "SupportedLanguages.h"

class wxUI;
class KissCount;

class PreferencesPanel: public wxPanel
{
 public:
  PreferencesPanel(KissCount* kiss, wxUI *parent);
  void ChangeUser();

  void OnAccountModified(wxGridEvent& event);
  void OnCategoryModified(wxGridEvent& event);
  void OnChangeName(wxCommandEvent& event);
  void OnChangePassword(wxCommandEvent& event);
  void OnLanguageChange(wxCommandEvent& event);
  void OnShow(wxShowEvent& event);
  void OnKillMe(wxCommandEvent& event);

 private:
  KissCount* _kiss;
  wxUI* _wxUI;
  wxGrid* _accountsGrid;
  wxGrid* _categoriesGrid;
  wxTextCtrl* _name;
  wxBitmapComboBox* _language;

  void InitAccounts(User* user);
  void InitCategories(User* user);
  void InitLanguage(User* user);

  DECLARE_EVENT_TABLE();
};

#endif
