#include "wxGridCellBitmapRenderer.h"

wxGridCellBitmapRenderer::wxGridCellBitmapRenderer(wxBitmap& bitmap) : _bitmap(bitmap)
{

}

wxGridCellRenderer* wxGridCellBitmapRenderer::Clone () const
{
  wxBitmap bitmap(_bitmap);
  return new wxGridCellBitmapRenderer(bitmap);
}

void wxGridCellBitmapRenderer::Draw (wxGrid &grid, wxGridCellAttr &attr, wxDC &dc, const wxRect &rect, int row, int col, bool isSelected)
{
  dc.SetBrush(wxBrush(grid.GetCellBackgroundColour(row, col)));
  dc.DrawRectangle(rect);
  dc.DrawBitmap (_bitmap, rect.x + (rect.width-_bitmap.GetWidth())/2, rect.y + (rect.height-_bitmap.GetHeight())/2, true);
}

wxSize wxGridCellBitmapRenderer::GetBestSize (wxGrid &grid, wxGridCellAttr &attr, wxDC &dc, int row, int col)
{
  return wxSize(_bitmap.GetWidth(), _bitmap.GetHeight());
}
