#ifndef WXUI_H
#define WXUI_H

#include <wx/wx.h>
#include "AccountPanel.h"
#include "ButtonPanel.h"
#include "PreferencesPanel.h"
#include "UsersDialog.h"
#include "GenerateDialog.h"
#include <controller/KissCount.h>

class KissCount;
class AccountPanel;
class PreferencesPanel;

extern wxString months[12];

class wxUI: public wxFrame
{
 public:

  wxUI(KissCount* kiss, const wxString& title, const wxPoint& pos, const wxSize& size);
  ~wxUI();

  bool SetLanguage(long language);

  void ChangeUser();
  void LoadUser();

  void ShowAccount();
  void ShowPreferences();
  void GenerateMonth(int month, int year);

  void KillMe();

  void ShowPanel(wxPanel* panel);
  void NeedReload();

  wxLanguage _language;

 private:
  KissCount    *_kiss;
  wxBoxSizer   *_hbox;
  AccountPanel *_accountPanel;
  PreferencesPanel *_preferencesPanel;
  wxPanel      *_curPanel;
  wxLocale     *_locale;
  bool         _needReload;
};

#endif
